/*

======================================================================

  Seyon is Copyright (c) 1992 of Muhammad M. Saggaf. Seyon is not
  public domain. Permission is granted to use and distribute Seyon
  freely for any use and to sell it at any price without reference to
  the copyright owner provided that in all above cases Seyon is intact
  and is not made part of any program either in whole or in part and
  that this copyright notice is included with Seyon. Permission is
  also granted to modify the source as long as the modified source is
  not distributed.

======================================================================

*/

#include <stdio.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include "seyon.h"
#include "SeDecl.h"
#include "SeDeclX.h"

char captureFile[REG_BUF];
FILE *cfp;
short capture = False;

void terminal_refresh(), toggle_capture();

void top_misc(w)
	 Widget w;
{
  Widget  popup, form, toggle;

  popup = SeCreatePopup("misc", w);
  form = SeAddForm("form", popup);

  SeAddButton("break", form, send_break);
  SeAddButton("refresh", form, terminal_refresh);
  toggle = SeAddToggle("capture", form, toggle_capture);
  SeAddButton("dismiss", form, DestroyPopupPrompt);
  
  SeSetUnsetToggle(toggle, capture);

  XtPopup(popup, XtGrabExclusive);
}

void terminal_refresh()
{
  restart_terminal();
  SeyonMessage("TERMINAL REFRESHED");
}

void toggle_capture(widget)
	 Widget widget;
{
  if(capture) {
	fclose(cfp);
	capture = False;
	SeyonMessage("CAPTURE TURNED OFF");
  } 
  else {
	if ((cfp = fopen(captureFile, "a")) == NULL) {
	  se_errorf("cannot open capture file %s", captureFile);
	} 
	else {
	  capture = True;
	  SeyonMessage("CAPTURE TURNED ON");
	}
  }

  SeSetUnsetToggle(widget, capture);
  restart_terminal();
}
