/*

======================================================================

  Seyon is Copyright (c) 1992 of Muhammad M. Saggaf. Seyon is not
  public domain. Permission is granted to use and distribute Seyon
  freely for any use and to sell it at any price without reference to
  the copyright owner provided that in all above cases Seyon is intact
  and is not made part of any program either in whole or in part and
  that this copyright notice is included with Seyon. Permission is
  also granted to modify the source as long as the modified source is
  not distributed.

======================================================================

*/

#include <stdio.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <X11/Xaw/List.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Viewport.h>

#include "seyon.h"
#include "SeDeclX.h"

extern Widget SeCreatePopup();
extern char *str_parse();
extern void exec_cmd();

Widget tr_form, upl_dialog;
char wbuf[WBSIZE], *cmd;

void do_transfer(), buf_transfer(), do_upload(), exec_upload(),
  ReReadProtocolsList();

void top_transfer(w)
	 Widget w;
{
  Widget  popup, form, view, list;
  static char protocolsFile[REG_BUF];
  static String prot[MAX_ENT + 1] = { NULL };
  Arg args[1];

  if (prot[0] == NULL)
	if (read_seyon_file(qres.protocolsFile, protocolsFile, prot) == 0)
	  return;

  popup = SeCreatePopup("transfer", w);
  form = SeAddForm("form", popup);
  view = XtCreateManagedWidget("view", viewportWidgetClass, form, NULL, 0);
  
  tr_form = form;

  XtSetArg(args[0], XtNlist, prot);
  list = XtCreateManagedWidget("list", listWidgetClass, view,
								 args, 1);
  XtAddCallback(list, XtNcallback, do_transfer, (XtPointer) form);

  SeSetViewportDimFromList(view, list, 10); 

  SeAddButton("dismiss", form, DestroyPopupPrompt);
  SeAddButtonWithClientData("edit", form, SeEditFile, 
							(XtPointer) protocolsFile);
  SeAddButtonWithClientData("reread", form, ReReadProtocolsList, 
							(XtPointer) prot);

  XtPopup(popup, XtGrabExclusive);
}

void ReReadProtocolsList(widget, list)
	 Widget widget;
	 XtPointer list;
{
  Widget form;
  char *ptr;

  form = XtParent(widget);
  DestroyPopupPrompt(NULL, form, NULL);  

  for(ptr = (char*) list; *ptr; ptr++)
	free(ptr);
  ((String*) list)[0] = NULL;

  top_transfer(XtParent(XtParent(form)));
}

void do_transfer(w, client_data, call_data)
	 Widget w;
	 XtPointer client_data, call_data;
{
  XawListReturnStruct *item = (XawListReturnStruct*) call_data;

  char /**cmd, */*cmdend, upload;
  char /*wbuf[WBSIZE],*/ *ptr;

  strcpy(wbuf, item->string);
  ptr = wbuf;

  str_parse(&ptr);
  if ((cmd = str_parse(&ptr)) == NULL)
	return;
  cmdend = ptr;
  
  upload = *str_parse(&ptr);
  *cmdend = '\0';

  if (upload == 'y' || upload == 'Y')
	{
	  do_upload(w, client_data); 
	  return;
	}
  else
	strcpy(wbuf, cmd);

  fork_exec_cmd(wbuf);
  DestroyPopupPrompt(NULL, client_data, (XtPointer) NULL);
 }

void do_upload(w, client_data)
	  Widget w;
	  XtPointer client_data;
 {
   Widget  popup, dialog;
   static XtPointer client_widget[2];

   popup = SeCreatePopup("upload", w);
   dialog = XtCreateManagedWidget("dialog", dialogWidgetClass, popup,
								  NULL, 0);

   upl_dialog = dialog;

   client_widget[0] = (XtPointer) dialog;
   client_widget[1] = client_data;

   XawDialogAddButton(dialog, "ok", exec_upload, 
					  client_widget);
   XawDialogAddButton(dialog, "cancel", DestroyPopupPrompt,
					  (XtPointer) dialog);
   
   XtPopup(popup, XtGrabExclusive);
 }

void exec_upload(w, client_data)
	 Widget w;
	 XtPointer client_data;
{
  Widget *client_widget;
  char *upload_file;
   
  /* 
   * client_widget[0] is the dialog widget of the upload popup
   * client_widget[1] is the form widget of transfer popup
   */

  client_widget = (Widget *) client_data;

  upload_file = XawDialogGetValueString(client_widget[0]);
  strcat(strcat(strcpy(wbuf, cmd), " "), upload_file);

  fork_exec_cmd(wbuf);

  DestroyPopupPrompt(NULL, (XtPointer) client_widget[1], NULL);
} 

void upload_acc_ok(widget, event, params, num_params)
	 Widget widget;      
	 XEvent *event;      
	 String *params; 
	 Cardinal *num_params;
{
  static Widget client_widget[2];
  
  client_widget[0] = upl_dialog;
  client_widget[1] = tr_form;

  exec_upload(widget, (XtPointer) client_widget, NULL);
}
 
void SeTransfer(w, client_data)
	 Widget w;
	 XtPointer client_data;
{
  Widget dialog = (Widget) client_data;
  String command = XawDialogGetValueString(dialog);

/*  KillTerm();*/
/*  shell_exec(command);*/
/*  DoTerm();*/
  fork_exec_cmd(command);

  DestroyPopupPrompt(NULL, (XtPointer) dialog, (XtPointer) NULL);
}
 
void top_shell(w)
	 Widget w;
{
  Widget  popup, dialog;

  popup = SeCreatePopup("shellCommand", w);
  dialog = SeAddDialog("dialog", popup);

  XawDialogAddButton(dialog, "ok", SeTransfer, (XtPointer) dialog);
  XawDialogAddButton(dialog, "cancel", DestroyPopupPrompt,
					 (XtPointer) dialog);

  XtPopup(popup, XtGrabExclusive);
}

void shell_acc_ok(widget, event, params, num_params)
	 Widget widget;      
	 XEvent *event;      
	 String *params; 
	 Cardinal *num_params;
{
  SeTransfer(widget, (XtPointer) XtParent(widget), (XtPointer) NULL);
}


