/*

======================================================================

  Seyon is Copyright (c) 1992 of Muhammad M. Saggaf. Seyon is not
  public domain. Permission is granted to use and distribute Seyon
  freely for any use and to sell it at any price without reference to
  the copyright owner provided that in all above cases Seyon is intact
  and is not made part of any program either in whole or in part and
  that this copyright notice is included with Seyon. Permission is
  also granted to modify the source as long as the modified source is
  not distributed.

======================================================================

*/

/* 
 * in the following, comment out the statements HAVE_{feature} if
 * your system does not support that feature
 */

/* 
 * configuration starts here
 */

#define HAVE_TERMIOS			/* if you have POSIX termios */
#define HAVE_TERMIO				/* if you have SYSV termio */

#define HAVE_DUP2				/* if you have dup2 */
#define	HAVE_STRSTR				/* if you have strstr */
#define	HAVE_STRDUP				/* if you have strdup */
#define HAVE_USLEEP				/* if you have usleep */

#define	DTR_DROPS_CARRIER		/* if dropping DTR drops carrier */

/*
    Some Berkely and Xenix systems have index() and rindex() which are
    functionally identical to the more standard strchr() and strrchr()
    functions.  Drop these defines if your Unix does supports index and
    rindex INSTEAD of strchr and strrchr.
*/

#define index     strchr		/* if you don't have index */
#define rindex    strrchr		/* if you don't have rindex */

/* 
 * configuration ends here 
 */

#if !defined(SIGCLD) && defined(SIGCHLD)
#define SIGCLD SIGCHLD
#endif

#define CAPTFILE    "capture.log"             /* default capture file */
#define LOCKFILE    "/usr/spool/uucp/LCK.."
#define LTMPFILE    "/usr/spool/uucp/LTMP."

#define NMSIZE  256				/* file name buffer size */
#define WBSIZE  256				/* input and working buffer size */
#define MAX_ENT 256				/* max number of entries in the dialing */
								/* directory and protocols file */

#define SM_BUF  80				/* number of chars in a small buffer */
#define REG_BUF 256				/* number of chars in a regular buffer */
#define LRG_BUF 1024			/* number of chars in a large buffer */
