.TH SEYON 1 \" -*- nroff -*-

.SH NAME
Seyon \- X11 Telecommunications Package.

.SH SYNOPSIS
.B seyon
[\-option ...] [\-toolkit_option ...] [\-\- \-emulator_option ...] [&]

.SH DESCRIPTION

.I Seyon 
is a complete full-featured telecommunications package for the 
.IR "X Window System" .
Some of its features are:

.IP
Dialing directory that supports an unlimited number of entries. The
directory is fully mouse-driven and features call progress monitoring,
dial timeout, automatic redial, multi-number dialing, and circular
redial queue. Each item in the dialing directory can be configured
with its own baud rate, bit mask, and script file.  The dialing
directory uses a plain-text phone book that can be edited from withen
Seyon. Seyon also supports manual dialing.
.IP
Terminal emulation window supporting DEC VT02, Tektronix 4014, and
ANSI. Seyon delegates its terminal emulation to xterm, so all the
familiar xterm functions such as the scroll-back buffer, cut-and-paste
utility, and visual bell are availabe through Seyon's terminal
emulation window. Using xterm also means that Seyon has a more
complete emulation of VT102 than other any Unix or DOS
telecommunications program. Other terminal emulation programs can also
be used with Seyon to suit the user's need; for example, color xterm
can be used to provide emulation for color ANSI (popular on many BBS
systems), and xvt can be used if memory is a bit tight.
.IP
Script language to automate tedious tasks such as logging into remote
hosts. Seyon's script interpreter uses plain-text files and has a
syntax similar to that of sh, with a few extra addtions. It supports
many familiar statements such as conditional branching by
\fIif\fP-\fIelse\fP and looping by \fIgoto\fP. Scripts may be assigned
to items in the dialing directory for automatic execution after a
connection is made.
.IP
Unlimited number of slots for external file transfer protocols.
Protocols are activated from a mouse-driven transfer console that uses
a plain-text file, editable from withen Seyon, for protocol
configuration. Seyon prompts the user for filenames only if the chosen
protocol requires filenames or if the transfer operation is an upload,
for which Seyon also accepts wildcards. Multiple download directories
can be specified for the different transfer slots.
.IP
Support for zmodem auto-download. Seyon detects incoming zmodem
signature and automatically activates a user-specified zmodem protocol
to receive incoming files. Zmodem transfers can thus be completely
automatic and require no user intervention.
.IP
Translation modes. Seyon can perfrom useful trasnlations on the user's
input. From example, Seyon can translate backspace to delete (useful
on may Unix systems), newline to carriage return (useful on many BBS
hosts), and my favorite, meta key tranlation: to send keys pressed
while the meta (ALT) key is held down as an escape (ESC) followed by
the key press. The latter mode simulates the meta key on hosts that do
not support 8-bit-clean connections and makes possible the use of the
meta key in programs like Emacs on such hosts.
.IP
Other features: interactive setting of program parameters, on-line
help, software (XONN/XOFF) and hardware (RTS/CTS) flow control,
session capture to a file, and temporary running of a local shell in
the terminal emulation window.

.P
Seyon is intended to be both simple and extensively configurable.
Almost every aspect of Seyon can be configured via the resources to
suit the user's taste.

.SH RESOURCES

.P
Besides the toolkit resources, Seyon defines the following proprietry
resources: 

.TP
.BI modem " (string)"
The modem device Seyon should use by default.
.I No default value.
.TP
.BI defaultBPS " (string)"
The default baud rate. Seyon will set the baud rate to this
value on startup and will use it for items in the dialing directory
for which no baud rate is given.
.I Default value: 9600
.TP
.BI sevenBitMask " (boolean)"
Whether Seyon should use 7 bits as the default bit mask. Seyon will set
the bit mask according to this value on startup and will use it for
items in the dialing directory for which no bit mask is given. If set
to
.IR off ,
the default bit mask used will be 8 bits.
.I Default value: off
.TP
.BI newlineTranslation " (boolean)"
Whether to translate user's newline character (\\n) to carriage return
(\\r). Users of BBS systems ought to set this to
.IR on ,
since many such systems expects a carriage return to delimit commands.
.I Default value: on
.TP
.BI backspaceTranslation " (boolean)"
Whether to translate user's backspace to delete. When the remote host
is a Unix system, it's better to set this to 
.IR on ,
since many Unix systems are not happy with backspace.
.I Default value: off
.TP
.BI metaKeyTranslation " (boolean)"
Whether to transmit keys pressed while the meta (ALT) key is held down
as an escape (ESC) followed by the key press. Most hosts do not
support 8-bit sessions, and hence do not recognize the meta key.
Therefore, this translation mode has to be enabled when connected to
such hosts to take advantage of the meta key in programs that make use
of it like Emacs.
.I Default value: on
.TP
.BI xonxoffFlowControl " (boolean)"
Whether Seyon should turn on XON/XOFF software flow control.
.I Default value: off
.TP
.BI rtsctsFlowControl " (boolean)"
Whether Seyon should turn on RTS/CTS hardware flow control. Make sure
the modem is set to use this as well.
.I Default value: off
.TP 
.BI dialPrefix " (string)"
The string Seyon sends to the modem before the phone number. To use
pulse dialing, set this resource to .IR ATDP .
.I Default value: ATDT
.TP 
.BI dialSuffix " (string)"
The string Seyon sends to the modem after the phone number. This
string has to contain a carraige return or the number will never get
sent to the mode.
.I Default value: \\\r
.TP 
.BI dialCancel " (string)"
The string Seyon sends to the modem to cancel dialing while in
progress.
.I Default value: \\\r
.TP 
.BI dialTimeOut " (short)"
How long in seconds Seyon should wait for a connection to made after
dialing is complete. Seyon will cancel the dialing if no connection is
made withen this period.
.I Default value: 45
.TP 
.BI dialDelay " (short)"
How long in seconds Seyon should wait after no connection is made
withen 
.IR dialTimeOut
before ciculating to the next number.
.I Default value: 10
.TP 
.BI dialRepeat " (short)"
How many times Seyon should try dialing a number. Seyon will give up
on dialing a number if no connection is made after this many tries.
.I Default value: 5
.TP 
.BI connectString " (string)"
The modem connect string. This the string response the modem gives
when a connection is made after dialing.
.I Default value: CONNECT
.TP
.BI noConnectString[1|2|3|4] " (string)"
The response strings given by the modem when connection fails. 
.IR "Default values: NO CARRIER" ", " "NO DIALTONE" ", " BUSY ", " VOICE
(respectively)
.TP
.BI hangupConfirm " (boolean)"
Whether Seyon should ask for confirmation before hanging up the phone
.I Default value: on
.TP
.BI exitConfirm " (boolean)"
Whether Seyon should prompt for hanguping up before exiting.
.I Default value: on
.TP
.BI zmodemAutoDownload " (boolean)"
Whether to enable ZMODEM auto-download. If set to
.IR on ,
Seyon will start ZMODEM downloads whenever it recieves the
auto-download string from the remote host.
.I Default value: on
.TP
.BI zmodemAutoDownloadCommand " (string)"
The shell command Seyon is to execute for ZMODEM auto-downloads.
.I Default value: rz
.TP
.BI funMessages " (string array)"
The fun messages to be displayed when Seyon has no other important
information to show. This should be a list of double-quoted sentences.
If the list is not empty, Seyon will display those messages at an
interval specified by the
.I funMessagesInterval
resource when there is no other important information to convey to the
user. To disable the display of fun messages, this resource has be
given with an empty list, since Seyon's default list of messages is
not empty.
.I Default value: varies, version-dependent
.TP
.BI funMessagesInterval " (int)"
The temporal interval in seconds between successive fun messages.
.I Default value: 60
.TP
.BI defaultDirectory " (string)"
Seyon's default directory. When looking for its files, Seyon will
first try the current directory, then this default directory, and
finally the user's home directory. Seyon will also put the capture
file in this directory.
.I Default value: ~/\.seyon
.TP
.BI scriptDirectory " (string)"
Seyon's script directory. When looking for scripts, Seyon will
first try the current directory, then this script directory, and
finally the user's home directory.
.I Default value: defaultDirectory
.TP
.BI startupFile " (string)"
Seyon's startup file. Seyon will execute all commands in this file
upon startup. This file can have any commands acceptable as script
commands. The most useful command to put here is the
.I set
command, to set the various communications parameters.
.I Default value: startup
.TP
.BI phonelistFile " (string)"
The name of the phone list (dialing directory) file. See the included
example to learn how this file should be formatted.
.I Default value: phonelist
.TP
.BI protocolsFile " (string)"
The name of the protocols file. This file tells Seyon what file transfer
protocols are available. The user will be promted with a list based on
this file when file transfer is to be initiated.
.I Default value: protocols
.TP
.BI captureFile " (string)"
The name of capture file. Seyon will write session captures to this
file when capture is enabled. This file will be placed in Seyon's
default directory. The capture file will not be overwritten by
successive capture sessions. Seyon will merely apped new capture to
its end. 
.I Default value: capture

.SH SCRIPT LANGUAGE

Script files can automate some tedious tasks such as logging into a
system.  A script file is an ascii text file and may be entered or
edited using any standard text editor.

The script file is read line by line.  Empty lines (consisting of
white space only) are ignored.  Comments are lines whose first
non-space character is a pound sign (#).

The script processor reads each script line, ignoring leading white
space, into \fIwords\fP. A word is defined as either:

.IP
.PD 0
\(bu a sequence of characters delimited by white space, or
.IP
\(bu a sequence of characters enclosed in single or double quotes.
.PD

.P
The first word of a script file is considered the \fIcommand word\fP.
If the last character of the command word is a colon (:), the line is
considered to be a \fIlabel\fP (the object of a \fIgoto\fP statement).
Otherwise, it is assumed to be a script command and is interpreted as
such. Command words are case insensative.

Some commands take one or more arguments. Each argument is parsed as a
single word as defined above.  If blanks are required in an argument,
the argument must be quoted using single or double quotes.

\" .SS Startup Scripts

\"    When XCOMM is started up, it looks for the file ".xcomm" in the current
\"    or $HOME directory.  If it is found, it is executed.  This is useful for
\"    setting your "basic" parameters without having to recompile XCOMM.  For
\"    example, your startup file may turn CIS <ENQ> mode off, set your baud
\"    rate to 9600, and set 7BIT translation.


.SS Script Command List

Below is the description of all commands that may be used in the Seyon
script language:

.TP
.BI "capture on|off" " (currently may not work)"
The command \fIcapture on\fP will enable capture. All characters
received during \fIwaitfor\fP processing will be appended to the capture
file. The command \fIcapture off\fP will close the capture file.
This setting does not currently extend to terminal mode. This may be
offered in a later release.

.TP
.BI dial " <number> (currently may not wwork)"
Dial the specified number.  Seyon supports generic "Hayes" compatible
modems for dialing.  Note that this command requires an actual phone
number. The phonebook is not used for this function.

.TP
.B echo on|off
If the argument to the \fIecho\fP command is \fIon\fP, all subsequent
command lines processed will be displayed on the local screen. The
exception to this is lines containing a \fItransmit\fP command. These
lines will just print \fITRANSMIT ...\fP, so that passwords, etc. can
be protected. If the argument to the \fIecho\fP command is \fIoff\fP,
scripts will execute quietly (this is the default setting).

.TP
.B exit
Terminates the script file prior to the end of file. Returns to
terminal mode.

.TP
.BI goto " <label>"
Goes to the specified label in the script file and continues execution
from that point. The label may either precede or follow the actual
\fIgoto\fP statement. A label is any \fIcommand word\fP whose last
character is a colon (:).

.TP
.BR if ", " else ", " endif
.I Syntax: 
.nf
\fIif\fP <condition>
        <statements>
[\fIelse\fP
        <statements>]
\fIendif\fP
.fi

Conditionally executes statements based on specified condition. Seyon
supports the following conditions:

.IP
.PD 0
\fIwaitfor\fP: true if the last \fIwaitfor\fP command was successful.
.IP
\fIlinked\fP: true if this script was executed from the dialing
directory.
.PD

Conditions may be negated using the prefix \fInot\fP or the character
\fI!\fP: 

.IP
.PD 0
\fI!waitfor\fP: true If the last \fIwaitfor\fP command timed out.
.IP
\fInot waitfor\fP: same as \fI!waitfor\fP above
.PD

The \fIelse\fP and \fIendif\fP keywords must appear on their own
lines. \fIIf\fP statements may not be nested.

.TP
.BI pause " <time>"
Suspends execution of the script for the specified number of seconds.
This is usually used for timing considerations; for example, waiting a
couple of seconds after receiving the \fIconnect\fP message and typing
^C to CompuServe.

.TP 
.BI quit " (currently does not work)"
Terminates the script and exits the whole program (returns to the
shell). 


.TP
.BI redial " (currently may not wwork)"
Redials the last number dialed using the \fIdial\fP command.

.TP
.BI set " <parameter> <value>"
Sets the specified parameter to the given value. Can be used to
set the various communications parameters for each host.

.TP
.BI transmit " <text>"
Transmits the specified text to the remote host. The text argument
should be quoted (using single or double quotes) if there are spaces
to be transmitted. The text is transmitted as is (no case conversions
are performed).

.I Prefix characters:
.IP
.PD 0
^ is the Control character prefix: the next character is made into a
control character. For example, ^M is \fIcarriage return\fP (0x0D) and
^J is \fInewline\fP (0x0A). 
.IP
\\ is quote prefix: the next character is transmitted verbatim. For
example, \\^ would transmit a literal ^.
.PD

.TP
.B tty on|off
This command specifies whether or not characters received from the
modem will be displayed on the local terminal.  Since the only time
that the script processor looks at the receive queue is during
\fIwaitfor\fP processing, the displays may look a bit erratic.
Use the \fItty off\fP command to disable local display of received
characters during script processing.

.TP 
.BI waitfor " <text> [timeout]"
Waits for the specified text to appear from the modem. The text
argument should be quoted (using single or double quotes) if there are
spaces to be transmitted.

Special characters are interpreted the same as for \fItransmit\fP.
If the timeout argument is specified, Seyon will wait that number of
seconds for the string to appear.  If no timeout is given, Seyon
defaults to 30 seconds.

During \fIwaitfor\fP processing, characters received (up to and
including the last character found in the text or in the timeout) can
be captured to a disk file (if \fIcapture on\fP is specified), and/or
displayed to the screen (if \fItty on\fP is specified).

.SH FILES
The default Seyon files are
.IR startup ", " phonelist ", and " protocols .
These have to be in the current directory, Seyon's default
directory
.RI ( ~/\.seyon "),"
or the user's home directory. The default script directory is Seyon's
default directory. All of these files and directories can be
overridden by setting the appropriate resources. See the description
of those resources as well as the description of the files above.

.SH SEE ALSO
xterm(1), resize(1)

.SH COPYRIGHT

Seyon is Copyright (c) 1992 of Muhammad M. Saggaf. Seyon is not public
domain. Permission is granted to use and distribute Seyon freely for
any use and to sell it at any price without reference to the copyright
owner provided that in all above cases Seyon is intact and is not made
part of any program either in whole or in part and that this copyright
notice is included with Seyon. Permission is also granted to modify
the source as long as the modified source is not distributed.

.SH AUTHOR

Muhammad M. Saggaf, alsaggaf@mit.edu

.SH ACKNOWLEDGEMENT

Many people, particularly David Boyce for helpful suggestions and the
Imakefile.